#!/bin/sh

PLUGIN_C=$1/plugin_include.c
HEADER_C_IN=$2/_header.c.in
SYMBOL_C_IN=$2/_symbol.c.in
FOOTER_C_IN=$2/_footer.c.in
FOREACH_C_IN=$2/_foreach.c.in
PLUGIN_TEMPLATE_DIR=$3

# Generate C code for finding and code for loading/installing a plugin 
for Plugin in `ls $PLUGIN_TEMPLATE_DIR/*.plugin`; do

. $Plugin

cat $HEADER_C_IN | sed s:@STRUCT_PREFIX@:$STRUCT_PREFIX:g | sed s:@PLUGIN_NAME@:$PLUGIN_NAME:g >> $PLUGIN_C

    for Member in `cat $Plugin.members`; do

	FUNC_NAME=`echo $Member|cut -f1 -d \:`
	MEMB_NAME=`echo $Member|cut -f2 -d \:`

	cat $SYMBOL_C_IN | sed s:@SYMBOL_NAME@:$MEMB_NAME:g >> $PLUGIN_C

    done

cat $FOOTER_C_IN | sed s:@PLUGIN_TYPE_NAME@:$PLUGIN_TYPE_NAME:g >> $PLUGIN_C
cat $FOREACH_C_IN | sed s:@PLUGIN_NAME@:$PLUGIN_NAME:g >> $PLUGIN_C

done

# Generate gchar* array with plugin type names 
echo "static gchar* plugin_type_names[] = {" >> $PLUGIN_C
for Plugin in `ls $PLUGIN_TEMPLATE_DIR/*.plugin`; do

. $Plugin

echo "	\"$PLUGIN_NAME\"," >> $PLUGIN_C

done

echo "	NULL" >> $PLUGIN_C
echo "};" >> $PLUGIN_C

echo >> $PLUGIN_C

echo "static DirForeachFunc plugin_dir_scan_funcs[] = {" >> $PLUGIN_C
for Plugin in `ls $PLUGIN_TEMPLATE_DIR/*.plugin`; do

. $Plugin

echo "	plugin_dir_foreach_func__$PLUGIN_NAME," >> $PLUGIN_C

done

echo "};" >> $PLUGIN_C


